using System;
using System.IO;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.Xml.Serialization;
using Syncfusion.Windows.Forms.Diagram;

namespace Diagram_WF_XMLSerialization
{
    public partial class Form1 : Form
    {
        private SymbolPalette palette = new SymbolPalette();
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Ellipse e1 = new Ellipse(100, 50, 50, 50);
            this.diagram1.Model.AppendChild(e1);
            Ellipse e2 = new Ellipse(250, 150, 50, 50);
            this.diagram1.Model.AppendChild(e2);

            this.palette.AppendChild(e1);
            this.paletteGroupView1.LoadPalette(palette);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.diagram1.Model.BackgroundStyle.Color = Color.Red;
            myModel my_Model = new myModel();
            //
            //Passing the Backgroundstyle here
            //
            my_Model.serial(this.diagram1.Model.BackgroundStyle);
            //
            //Serializing
            //
            XmlSerializer s = new XmlSerializer(typeof(myModel));
            TextWriter w = new StreamWriter(@"c:\myModel.xml");
            s.Serialize(w, my_Model);
            w.Close();
            Console.WriteLine("Completed");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            //
            //DeSerializing
            //
            myModel DModel;
            XmlSerializer s = new XmlSerializer(typeof(myModel));
            TextReader r = new StreamReader(@"c:\myModel.xml");
            //
            //ReConstructs the Backgroundstyle properties
            //
            DModel = (myModel)s.Deserialize(r);
            r.Close();
            Console.WriteLine("Done!");
            DModel.myStyle.Color = Color.BlanchedAlmond;
            this.diagram1.Model.BackgroundStyle.Color = DModel.myStyle.Color;
        }
    }
}
